<?php

namespace App\Traits;
use App\Repositories\Auth\BiodataRepository;
use App\Repositories\Auth\RoleRepository;
use App\Repositories\Auth\UserRepository;
use App\Repositories\UserdetailRepository;

use Illuminate\Support\Str;

trait LoginTrait
{
    private $userRepo;
    private $roleRepo;
    private $biodataRepo;
    private $userDetailRepo;

    public function __construct(
        UserRepository $userRepo,
        RoleRepository $roleRepo,
        BiodataRepository $biodataRepo,
        UserdetailRepository $userDetailRepo
    ) {
        $this->userRepo = $userRepo;
        $this->roleRepo = $roleRepo;
        $this->biodataRepo = $biodataRepo;
        $this->userDetailRepo = $userDetailRepo;
    }

    public function login_reviewer($nip)
    {
        $user = $this->userRepo->find(null, $nip, null);

        if ($user) {
            return $this->getlogin($user->id);
        } else {
            return $this->getAddReviewer($nip);
        }
    }

    private function getAddReviewer($nip)
    {
        $id = (string) Str::uuid();
        $data = collect([
            (object) [
                'jenis' => 'P',
                'userid' => $nip
            ]
        ]);
        $biodata = $this->biodataRepo->biodata($data->toArray());
        $user = $this->userRepo->storeSso($id, $biodata);
        $roles = $this->roleRepo->roles('reviewer');
        $this->userDetailRepo->storeSso($user->id, $biodata);
        $this->roleRepo->store($user, $roles);

        return 'sukses';
    }
}
